<template>
  <div class="col q-pa-md">
    <div class="text-h6 q-mb-sm">Breakout Room Recordings</div>
    <q-list>
      <q-item v-for="details in this.breakoutRoomDetails">
        <div class="q-item-section">
          {{ details.name }}
          <span v-if="details.isRecording">
            <q-icon class="text-red" name="fiber_manual_record" />
            recording now
          </span>
          <span v-else>
            <q-icon name="stop" />
          </span>
          {{ details.completedRecordings === 0 ? null
          : `(completed ${details.completedRecordings} recording${details.completedRecordings === 1 ? "" : "s"})` }}
        </div>
      </q-item>
    </q-list>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import * as firebase from "firebase/app";
import { ZoomSenseClientFirebaseDB, ZoomSenseMeetingChatNode } from "@zoomsense/zoomsense-firebase";
import {
  BreakoutRecordingPluginEventType,
  BreakoutRecordingPluginMeeting
} from "zoomsense-plugin-breakoutroom-recording-shared";

interface BreakoutRoomDetails {
  name: string;
  isRecording: boolean;
  completedRecordings: number;
}

const sensorPrefix = "ZoomSensor_";

export default Vue.extend({
  name: "Dashboard",
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    functions: {
      required: true,
      type: Object as () => firebase.functions.Functions,
    },
    context: {
      required: true,
      type: Object as () => ({meetingId: string, userId: string}),
    },
  },
  data() {
    return {
      chats: {} as {[sensorName: string]: ZoomSenseMeetingChatNode},
      meetingRecording: {} as BreakoutRecordingPluginMeeting
    }
  },
  computed: {
    breakoutRoomDetails(): BreakoutRoomDetails[] {
      return Object.keys(this.chats)
        .filter((name) => (name.startsWith(sensorPrefix) && this.chats[name].isInBO))
        .map((sensorName) => {
          const name = `Room ${sensorName.substring(sensorPrefix.length)}`;
          const { isRecording, completedRecordings } = Object.values(this.meetingRecording[sensorName]?.events ?? {})
            .reduce(({ completedRecordings }, event) => ({
              isRecording: (event.type === BreakoutRecordingPluginEventType.start),
              completedRecordings: (event.type === BreakoutRecordingPluginEventType.stop) ? completedRecordings + 1 : completedRecordings
            }), { isRecording: false, completedRecordings: 0 });
          return {
            name,
            isRecording,
            completedRecordings
          };
        })
    }
  },
  async created() {
    await Promise.all([
      this.$typedRtdbBind("chats", this.firebase.ref(`data/chats/${this.context.meetingId}`)),
      this.$typedRtdbBind("meetingRecording", this.firebase.ref(`data/plugins/boRecording/${this.context.meetingId}`))
    ])
  }
});
</script>
